summaryrefslogtreecommitdiff
path: root/eclass
diff options
context:
space:
mode:
authorBen de Groot <yngwin@gentoo.org>2012-07-23 12:44:06 +0000
committerBen de Groot <yngwin@gentoo.org>2012-07-23 12:44:06 +0000
commit896638e0cdd4046c9cadd4d81ea7471ddf41abfd (patch)
treeb2a2d757614d28d39e2dd1616174e9bdb3bc0280 /eclass
parentRevision bump to use new eclass. (diff)
downloadhistorical-896638e0cdd4046c9cadd4d81ea7471ddf41abfd.tar.gz
historical-896638e0cdd4046c9cadd4d81ea7471ddf41abfd.tar.bz2
historical-896638e0cdd4046c9cadd4d81ea7471ddf41abfd.zip
Initial commit of l10n.eclass
Diffstat (limited to 'eclass')
-rw-r--r--eclass/ChangeLog5
-rw-r--r--eclass/l10n.eclass121
2 files changed, 125 insertions, 1 deletions
diff --git a/eclass/ChangeLog b/eclass/ChangeLog
index 82dc16eb6524..969233408ed2 100644
--- a/eclass/ChangeLog
+++ b/eclass/ChangeLog
@@ -1,6 +1,9 @@
# ChangeLog for eclass directory
# Copyright 1999-2012 Gentoo Foundation; Distributed under the GPL v2
-# $Header: /var/cvsroot/gentoo-x86/eclass/ChangeLog,v 1.348 2012/07/23 10:57:15 jmbsvicetto Exp $
+# $Header: /var/cvsroot/gentoo-x86/eclass/ChangeLog,v 1.349 2012/07/23 12:44:06 yngwin Exp $
+
+ 23 Jul 2012; Ben de Groot <yngwin@gentoo.org> +l10n.eclass:
+ Initial commit of l10n.eclass
23 Jul 2012; Jorge Manuel B. S. Vicetto <jmbsvicetto@gentoo.org>
mysql.eclass, mysql-v2.eclass:
diff --git a/eclass/l10n.eclass b/eclass/l10n.eclass
new file mode 100644
index 000000000000..dffcbb620df3
--- /dev/null
+++ b/eclass/l10n.eclass
@@ -0,0 +1,121 @@
+# Copyright 1999-2012 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/eclass/l10n.eclass,v 1.1 2012/07/23 12:44:06 yngwin Exp $
+
+# @ECLASS: l10n.eclass
+# @MAINTAINER:
+# Ben de Groot <yngwin@gentoo.org>
+# @BLURB: convenience functions to handle localizations
+# @DESCRIPTION:
+# The l10n (localization) eclass offers a number of functions to more
+# conveniently handle localizations (translations) offered by packages.
+# These are meant to prevent code duplication for such boring tasks as
+# determining the cross-section between the user's set LINGUAS and what
+# is offered by the package; and generating the right list of linguas_*
+# USE flags.
+
+# @ECLASS-VARIABLE: PLOCALES
+# @DEFAULT_UNSET
+# @DESCRIPTION:
+# Variable listing the locales for which localizations are offered by
+# the package. Check profiles/desc/linguas.desc to see if the locales
+# are listed there. Add any missing ones there.
+#
+# Example: PLOCALES="cy de el_GR en_US pt_BR vi zh_CN"
+
+# @ECLASS-VARIABLE: PLOCALE_BACKUP
+# @DEFAULT_UNSET
+# @DESCRIPTION:
+# In some cases the package fails when none of the offered PLOCALES are
+# selected by the user. In that case this variable should be set to a
+# default locale (usually 'en' or 'en_US') as backup.
+#
+# Example: PLOCALE_BACKUP="en_US"
+
+# Add linguas useflags
+for u in ${PLOCALES}; do
+ IUSE+=" linguas_${u}"
+done
+
+# @FUNCTION: l10n_for_each_locale_do
+# @USAGE: <function>
+# @DESCRIPTION:
+# Convenience function for processing localizations. The parameter should
+# be a function (defined in the consuming eclass or ebuild) which takes
+# an individual localization as (last) parameter.
+#
+# Example: l10n_for_each_locale_do install_locale
+l10n_for_each_locale_do() {
+ local locs x
+ locs=$(l10n_get_locales)
+ for x in ${locs}; do
+ "${@}" ${x} || die "failed to process enabled ${x} locale"
+ done
+}
+
+# @FUNCTION: l10n_for_each_disabled_locale_do
+# @USAGE: <function>
+# @DESCRIPTION:
+# Complementary to l10n_for_each_locale_do, this function will process
+# locales that are disabled. This could be used for example to remove
+# locales from a Makefile, to prevent them from being built needlessly.
+l10n_for_each_disabled_locale_do() {
+ local locs x
+ locs=$(l10n_get_locales disabled)
+ for x in ${locs}; do
+ "${@}" ${x} || die "failed to process disabled ${x} locale"
+ done
+}
+
+# @FUNCTION: l10n_find_plocales_changes
+# @USAGE: <translations dir> <filename pre pattern> <filename post pattern>
+# @DESCRIPTION:
+# Ebuild maintenance helper function to find changes in package offered
+# locales when doing a version bump. This could be added for example to
+# src_prepare
+#
+# Example: l10n_find_plocales_changes "${S}/src/translations" "${PN}_" '.ts'
+l10n_find_plocales_changes() {
+ [[ $# -ne 3 ]] && die "Exactly 3 arguments are needed!"
+ einfo "Looking in ${1} for new locales ..."
+ pushd "${1}" >/dev/null || die "Cannot access ${1}"
+ local current= x=
+ for x in ${2}*${3} ; do
+ x=${x#"${2}"}
+ x=${x%"${3}"}
+ current+="${x} "
+ done
+ popd >/dev/null
+ if [[ ${PLOCALES} != ${current%[[:space:]]} ]] ; then
+ einfo "There are changes in locales! This ebuild should be updated to:"
+ einfo "PLOCALES=\"${current%[[:space:]]}\""
+ else
+ einfo "Done"
+ fi
+}
+
+# @FUNCTION: l10n_get_locales
+# @USAGE: [disabled]
+# @DESCRIPTION:
+# Determine which LINGUAS USE flags the user has enabled that are offered
+# by the package, as listed in PLOCALES, and return them. In case no
+# locales are selected, fall back on PLOCALE_BACKUP. When the disabled
+# argument is given, return the disabled useflags instead of the enabled
+# ones. This function is normally used internally in this eclass, not by
+# l10n.eclass consumers.
+l10n_get_locales() {
+ local disabled_locales enabled_locales loc locs
+ for loc in ${PLOCALES}; do
+ if use linguas_${loc}; then
+ enabled_locales+="${loc} "
+ else
+ disabled_locales+="${loc} "
+ fi
+ done
+ if [[ ${1} == disabled ]]; then
+ locs=${disabled_locales}
+ else
+ locs=${enabled_locales:-$PLOCALE_BACKUP}
+ fi
+ printf "%s" "${locs}"
+}